require "locale";
require "infoImage";

displayimage = "true";
local i = 1;

sel = celestia:getselection();
selname = sel:name();
selnames = {};
lastselname = "";

imagefilename = {};
image = {};

width2, height2 = celestia:getscreendimension();
xImageSize = 256;
yImageSize = 256;
yImageRatio = 256/yImageSize;

function getImageSize(i)
	xImageSize = image[i]:getwidth();
	yImageSize = image[i]:getheight();
end

function cleanfilenames()
	for n = 1, 50 do -- no more than 50 images for an object...
		imagefilename[n] = "";
	end
end

imageBox = CXBox:new()
	:init(0, 0, 0, 0)
	:text(_("Image"))
	:movable(false)
	:active(false)
	:visible(false)
	:attach(screenBox, width2-xImageSize-2, 30, 2, height2-yImageSize-30-24)
	-- si 2 positifs => carts par rapport aux bords (en pixels)
	-- si 1 positif et 1 ngatif => positif = offset ; ngatif = dimension fixe (en pourcentage si 0 < left < 1, en pixels si left = 0)	

imageBox.Customdraw = 
	function(this)
		width2, height2 = celestia:getscreendimension();
		--if width2 ~= lastwidth2 or height2 ~= lastheight2 then
			--lastwidth2 = width2;
			--lastheight2 = height2;
			imageBox:attach(screenBox, width2-xImageSize-2, 30, 2, height2-yImageSize-30-24)
		--end
		sel = celestia:getselection();
		selname = sel:name();
		if selname ~= lastselname then
			lastselname = selname;
			i = 1;
		end
		selnames[1] = selname..1;
		selnames[2] = selname..2;
		if infoImage[selnames[2]] then
			currentBox:visible(true);
		else
			currentBox:visible(false);
		end
		if infoImage[selnames[1]] then
			displayimage = "true";
		else
			--if imagefilename[i] then
				cleanfilenames();
				imageBox:attach(screenBox, width2-128-2, 30, 2, height2-normalfont:getheight()+5-30);
				imageFrame.Fillimage = nil;
				textlayout:setfont(normalfont);
				textlayout:setfontcolor({0.8, 0.8, 0.9, 0.5});
				textlayout:printinbox(_("No image available."), imageFrame, 0, -3);
				displayimage = "false";
			--end
		end
		selnames[i] = selname..i;
		if displayimage == "true"  then
			if imagefilename[i] ~= infoImage[selnames[i]] then
				imagefilename[i] = infoImage[selnames[i]];
				image[i] = celestia:loadtexture(imagefilename[i]);
				getImageSize(i);
				imageBox:attach(screenBox, width2-xImageSize-2, 30, 2, height2-yImageSize-30-24)
				imageFrame:fillimage(image[i]);
				yImageRatio = 256/yImageSize;
				currentBox:attach(imageBox, xImageSize-79, 0, 0, -0.08*yImageRatio);
				nextButton:attach(currentBox, 55, 0, -24, 0)
				previousButton:attach(currentBox, 0, 0, -24, 0)
			end
		end
	end;

imageFrame = CXBox:new()
	:init(0,0,0,0)
	:bordercolor({1, 1, 1, 0.3})
	:movable(false)
	:active(false)
	:visible(true)
	:attach(imageBox, 0, 24, 0, 0)

currentBox = CXBox:new()
	:init(0,0,0,0)
	--:bordercolor({0.2, 0.2 , 0.6, 0.2})
	:movable(false)
	:active(false)
	:visible(true)
	:attach(imageBox, xImageSize-79, 0, 0, -0.08*yImageRatio);
	
currentBox.Customdraw = 
	function(this)
		selmax = selname.."max";
		if infoImage[selmax] then
			cmax = infoImage[selmax];
			textlayout:setpos(this.lb+28, this.tb-15);
			textlayout:setfontcolor({0.7, 0.7 , 1, 0.6});
			textlayout:println(i.. " / ".. cmax);
		end
	end;

nextButton = CXBox:new()
				:init(0,0,0,0)
				:bordercolor({0.2, 0.2 , 0.6, 0.6})
				:textfont(titlefont)
				:text(">")
				:attach(currentBox, 55, 0, -24, 0)
				:movable(false)
				:visible(true)
				:active(true)

nextButton.Action = (function()
	return
	function()
			i = i + 1;
			cleanfilenames();
			selnames[i] = selname..i;
			if not(infoImage[selnames[i]]) then
				i = 1;
			end
		end
	end) ();

previousButton = CXBox:new()
				:init(0,0,0,0)
				:bordercolor({0.2, 0.2 , 0.6, 0.6})
				:textfont(titlefont)
				:text("<")
				:attach(currentBox, 0, 0, -24, 0)
				:movable(false)
				:visible(true)
				:active(true)

previousButton.Action = (function()
	return
	function()
			i = i - 1;
			cleanfilenames();
			selnames[i] = selname..i;
			if not(infoImage[selnames[i]]) then
				i = cmax;
			end
		end
	end) ();
