require "locale";

width3, height3 = celestia:getscreendimension();
yScreenRatio3 = 722/height3;

local lightLevel = celestia:getambient();
lightPos = lightLevel*114;

firstStart = true;

lightBox = CXBox:new()
	:init(0, 0, 0, 0)
	:text(_("Light"))
	--:bordercolor({1, 1, 0, 1})
	--:fillcolor({1,1,0,.2})
	:movable(false)
	--:attach(screenBox, (width3-146)/2, 0.91, (width3-146)/2, -0.06*yScreenRatio3)
	:attach(screenBox, width3-146-4, 0.72, 4, -0.06*yScreenRatio3)

lightBox.Customdraw = 
	function(this)
		local lightLevel = celestia:getambient();
		textlayout:setpos(this.lb+5, this.tb-15);
		textlayout:setfont(normalfont);
		textlayout:setfontcolor({0.8, 0.8, 0.9, 0.9});
		lightLevel_str = string.format("%1.2f", lightLevel);
		textlayout:println(_("Ambient Light Level").." : "..lightLevel_str);
		width3, height3 = celestia:getscreendimension();
		--if width3 ~= lastwidth3 or height3 ~= lastheight3 then
			--lastwidth3 = width3;
			--lastheight3 = height3;
			yScreenRatio3 = 722/height3;
			--lightBox:attach(screenBox, (width3-146)/2, 0.91, (width3-146)/2, -0.06*yScreenRatio3);
			lightBox:attach(screenBox, width3-146-4, 0.72, 4, -0.06*yScreenRatio3)
		--end
	end;		 

slideLightFrame = CXBox:new()
	:bordercolor({0.8, 0.8, 1, 0.4})
	--:fillcolor({.2,.2,.6,.1})
	:attach(lightBox, 8, 6, 8, 24)
	:visible(true)
	
slideLightFrame.Customdraw = 
	function(this)
		lb3,bb3,rb3,tb3 = slideLightFrame:bounds();
		lb4,bb4,rb4,tb4 = slideLightBox:bounds();
		lightValue = (lb4-lb3-3)/114;
		if lastLightValue ~= lightValue and firstStart == false then
			lastLightValue = lightValue;
			celestia:setambient(lightValue);
		end
		firstStart = false;
	end;

slideLightBox = CXBox:new()
	:bordercolor({0.2, 0.2 , 0.6, 0.6})
	:fillcolor({0.2, 0.2, 0.6, 0.3})
	:attach(slideLightFrame, 3+lightPos, 0, 117-lightPos, 0)
	:visible(true)
	:movable(true)
	
slideLightBox.Customdraw = 
	function(this)
		local lightLevel = celestia:getambient();
		if lastLightLevel ~= lightLevel then
			lastLightLevel = lightLevel;
			lightPos = lightLevel*114;
			slideLightBox:attach(slideLightFrame, 3+lightPos, 0, 117-lightPos, 0);
		end
	end;
