require "locale";

measureBox = CXBox:new()
	:init(0, 0, 0, 0)
	:textfont(titlefont)
	--:fillcolor({.2,.2,.6,.4})
	:text(_("Measure"))
	:bordercolor({0,0,0,0})
	:movable(false)
	:attach(screenBox, 0, 0.71, -0.11,-0.07);

measureBox.Customdraw = 
	function(this)
		measureBox:attach(screenBox, 0, 0.71, -0.11,-0.07);
		local sel = celestia:getselection();
		local obs = celestia:getobserver();
		if empty(sel) then
			ra_str = "";
			dec_str = "";
			dist_to_earth_str = "";
		else
		    local dist_to_earth = celutil.get_dist_to_earth(sel);
		    local ra,dec = celutil.get_ra_dec(sel);
			if dist_to_earth < 9466411000000.842 then
				ra_str = "-";
				dec_str = "-";
			else
				ra_str = string.format("%3.2f°", ra);
				dec_str = string.format("%3.2f°", dec);
			end
			if dist_to_earth < 0 then
				dist_to_earth_str = "-";
			else
				dist_to_earth_str = format:km(dist_to_earth);
			end
		end
		textlayout:setfont(normalfont);
		textlayout:setlinespacing(normalfont:getheight());
		textlayout:setfontcolor({0.7, 0.7, 1, 1});
		textlayout:setpos(this.lb, this.tb-20);
		textlayout:println("RA : "..ra_str);
		textlayout:println("Dec : "..dec_str);
		textlayout:println(_("Distance to Earth").." : "..dist_to_earth_str);
	end;		 
