require "locale";

radecBox = CXBox:new()
	:init(0, 0, 0, 0)
	:textfont(titlefont)
	--:fillcolor({.2,.2,.6,.4})
	:text(_("RA-Dec"))
	:bordercolor({0,0,0,0})
	:movable(false)
	:attach(screenBox, 0, 0.71, -0.11,-0.07);

radecBox.Customdraw = 
	function(this)
		radecBox:attach(screenBox, 0, 0.71, -0.11,-0.07);
		local sel = celestia:getselection();
		--local selname = sel:name();
		textlayout:setpos(this.lb, this.tb-20);
		textlayout:setlinespacing(15);
		textlayout:setfont(normalfont);
		textlayout:setfontcolor({0.7, 0.7, 1, 1});
		--if selname == "?" or selname == "Earth" then
		if empty(sel) then
			ra_str = "";
			dec_str = "";
			dist_str = "";
		else
		    local dist_to_earth = celutil.get_dist_to_earth(sel);
			local ra,dec = celutil.get_ra_dec(sel);
			if dist_to_earth < 1 then
				ra_str = "-";
				dec_str = "-";
				dist_str = " < 1 ".._("ly");
			else
				ra_str = string.format("%3.2f'", ra);
				dec_str = string.format("%3.2f'", dec);
				dist_str = string.format("%1.2f", dist_to_earth).." ".._("ly");
			end
		end
		textlayout:println("RA : ".. ra_str);
		textlayout:println("Dec : ".. dec_str);
		textlayout:println(_("Dist. to Earth").." : ".. dist_str);
	end;		 
