-- tourBox.lua

tourStop = { "Moon", "Phobos", "Saturn", "Enceladus", "Eros", "Pluto", "Mercury" };

tourBox = CXBox:new()
	:init(300,30,-80,-40)
	:textfont(titlefont)
	:fillcolor({.2,.2,.6,.3})
	:text("Tour")
	:bordercolor({0,1,1,1})
	:attach(screenBox,5,-120,-280,5)
	:movable(true)

tourBox.nextstop = 1;
tourBox.going = false;
tourBox.Customdraw = 
	function(this)
		textlayout:setpos(this.lb+10, this.tb);
		textlayout:newln();
		textlayout:newln();
		obs = celestia:getobserver();
		if not obs:travelling() then tourBox.going = false end;
		if tourBox.going then
			textlayout:println("En route to "..tourStop[tourBox.pos].."...")
		else
			ref = obs:getframe():getrefobject();
			textlayout:println("Exploring "..ref:name());
		end;
		textlayout:newln();
		if tourBox.nextstop == 1 then
			textlayout:println("First Tour Stop: "..tourStop[tourBox.nextstop])
		else
			textlayout:println("Next Tour Stop: "..tourStop[tourBox.nextstop])
		end
	end;
		
goButton = CXBox:new()
	:text("Go")
	:textfont(titlefont)
	:bordercolor({0,1,1,1})
	:attach(tourBox,-50,5,5,-20)
	:visible(true)
	:active(true)
	:action(function() 
		tourBox.pos = tourBox.nextstop;
		tourBox.nextstop = tourBox.pos+1;
		if tourBox.nextstop > 7 then tourBox.nextstop = 1 end;
		obj = celestia:find( tourStop[tourBox.pos] );
		obs = celestia:getobserver();
		d = obj:radius()*7;
		tourBox.going = true;
		obs:gotodistance(obj,d,math.log(d)*1.5);
		celestia:select(obj);
		end)

backButton = CXBox:new()
	:text("Back")
	:textfont(titlefont)
	:bordercolor({0,1,1,1})
	:attach(tourBox,5,5,-80,-20)
	:visible(true)
	:active(true)
	:action(function() 
		tourBox.pos = tourBox.pos-1;
		if tourBox.pos <= 1 then tourBox.pos = 1 end;
		tourBox.nextstop = tourBox.pos+1;
		if tourBox.nextstop > 7 then tourBox.nextstop = 1 end;
		obj = celestia:find( tourStop[tourBox.pos] );
		obs = celestia:getobserver();
		d = obj:radius()*7;
		tourBox.going = true;
		obs:gotodistance(obj,d,math.log(d)*1.5);
		celestia:select(obj);
		end)
	

