textlayout = {};

textlayout.init = 
	function(this)
		this.xpos = 0;
		this.ypos = 0;
		this.linespace = 10;
		--this.leftmargin = 15;
		--this.linestart = 15;
		--this.em = 8;
		this.indent = 0;
		this.xpos = 0;
		--this.linestart = xpos;
		this.ypos = 0;
		this.font = nil;
		this.color = {0.8, 0.8, 0.9, 0.9};
	end
	
textlayout.print = 
	function(this,s)

--[[		gl.drawtext(s,this.xpos,this.ypos); ]]
--[[		gl.begintext(this.xpos,this.ypos); ]]
	
		--color = {0.7, 0.7, 0.8, 0.8};
--		gl.Color(0.8, 0.5, 0.5, 1.0);
		gl.Color(unpack(this.color));
		gl.Enable(gl.TEXTURE_2D);

		gl.Enable(gl.BLEND);
		gl.BlendFunc(gl.SRC_ALPHA, gl.ONE_MINUS_SRC_ALPHA);
--[[	glGetIntegerv ( gl.VIEWPORT, vpmax ); ]]
		gl.MatrixMode(gl.PROJECTION);
		gl.PushMatrix();
		gl.LoadIdentity();
--[[    gluOrtho2D(0, vpmax[2], 0, vpmax[3]); ]]

		sx,sy = celestia:getscreendimension();

	    gl.Ortho(0, sx+0, 0, sy+0, 0, 1); 
    	gl.MatrixMode(gl.MODELVIEW);
		gl.PushMatrix();
		gl.LoadIdentity();
		local xpos = math_round(this.xpos);
		local ypos = math_round(this.ypos);
		gl.Translate(xpos+0.125, ypos+0.125);

		this.font:bind();
		this.font:render(s);

--[[		gl.endtext(); ]]
 
    gl.PopMatrix();
    gl.MatrixMode(gl.PROJECTION);
    gl.PopMatrix();
    gl.MatrixMode(gl.MODELVIEW);

	end
	
textlayout.newln = 
	function(this)
		this.xpos = this.leftmargin+this.indent;
		this.linestart = this.xpos;
		this.ypos = this.ypos - this.linespace;		
	end
	
textlayout.println = 
	function(this,s)
		this:print(s);
		this:newln();		
	end

textlayout.setpos = 
	function(this,x,y)
		this.leftmargin = x;
		this.indent = 0;
		this.linestart = x;
		this.xpos = x;
		this.ypos = y;
	end

textlayout.printinbox = 
	function(this,s,b,x,y)
		local textwidth = this.font:getwidth(s);
		local textheight = this.font:getheight();
		local boxwidth, boxheight = b:size();
		local x_pos = (boxwidth-textwidth)/2;
		local y_pos = (boxheight+textheight)/2;
		this.leftmargin = b.lb + x_pos + x;
		this.indent = 0;
		this.linestart = b.lb + x_pos + x;
		this.xpos = b.lb + x_pos + x;
		this.ypos = b.tb - y_pos - y;
		this:print(s);
		this:newln();	
	end

textlayout.setfont = 
	function(this,f)
		this.font = f;
	end
	
textlayout.setfontcolor = 
	function(this,c)
		this.color = c;
	end

textlayout.setlinespacing = 
	function(this,x)
		this.linespace = x;
	end

textlayout.indentby = 
	function(this,x)
		this.indent = this.indent+(x*this.em);
		if this.xpos == this.linestart then 
			this.xpos = this.leftmargin+this.indent;
		end; 
	end
